#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <png.h>

int main(int argc, char *argv[])
{
	int num, srccount, i, j, k, l, bit, count, maskptr, n;
	int filesize, xsize, ysize, size;
	unsigned char *repeat, *buf, *bufend, *src;
	unsigned char *srcbuf;
	unsigned char flag;
	int index[16];
	unsigned char tmp[32];

	unsigned char *mask = NULL;
	unsigned char *buffer = NULL;
	srcbuf = 0;
	
	if(argc < 2) {
		printf("usage: %s <pdt file> <png file>\n",argv[0]);
		return 0;
	}

	FILE *fp = fopen(argv[1], "rb");
	if ( fp ) {
		fseek(fp, 0, 0);
		fread(tmp, 32, 1, fp);
		if (!memcmp(tmp, "PDT1", 4)) {
			filesize = (*(tmp+11) << 24) | (*(tmp+10) << 16) | (*(tmp+9) << 8) | *(tmp+8);
			xsize    = (*(tmp+15) << 24) | (*(tmp+14) << 16) | (*(tmp+13) << 8) | *(tmp+12);
			ysize    = (*(tmp+19) << 24) | (*(tmp+18) << 16) | (*(tmp+17) << 8) | *(tmp+16);
			maskptr  = (*(tmp+31) << 24) | (*(tmp+30) << 16) | (*(tmp+29) << 8) | *(tmp+28);
			size     = xsize * ysize;
			if ( filesize>32 ) {
				srcbuf = (unsigned char*)malloc(filesize);
				if ( srcbuf ) {
					fread(srcbuf+32, filesize-32, 1, fp);
					memcpy(srcbuf, tmp, 32);
				}
			}
		}
		fclose(fp);
	}

	if ( srcbuf ) {
		if ( maskptr ) {								// Mask
			mask = (unsigned char*)malloc(size);
			memset(mask, 0, size);
			src = srcbuf+maskptr;
			bit = 0;
			srccount = filesize-maskptr;
			bufend = mask+size;
			buf = mask;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					*buf++ = *src++;
					srccount--;
				} else {
					count = (*src++)+2;
					repeat = buf-((*src++)+1);
					srccount -= 2;
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}
		}

		size *= 3;	// RGB1Х
		buffer = (unsigned char*)malloc(size);
		if ( !strcmp((char*)srcbuf, "PDT10") ) {
		// PDT10
			src = srcbuf+32;
			bit = 0;
			if ( maskptr )
				srccount = maskptr-32;
			else
				srccount = filesize-32;
			bufend = buffer+size;
			buf = buffer;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					*buf++ = *src++;
					*buf++ = *src++;
					*buf++ = *src++;
					srccount -= 3;
				} else {
					num  = *src++;
					num += ((*src++)<<8);			// ϥȥ륨ǥWORD
					srccount -= 2;
					count = ((num&15)+1)*3;			// 4bitԡ. 2󤬺Ǿñ̡
					repeat = buf-((num>>4)+1)*3;	// bufϼν񤭹֤߰ؤƤΤǡ1Х¿
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}

		} else {
		// PDT11
			for (i=0; i<16; i++) {					// ԡȿIndexTable
				index[i]  = (srcbuf[i*4+0x420]);
				index[i] |= (srcbuf[i*4+0x421]<<8);
				index[i] |= (srcbuf[i*4+0x422]<<16);
				index[i] |= (srcbuf[i*4+0x423]<<24);
			}
			src = srcbuf+0x460;
			bit = 0;
			if ( maskptr )
				srccount = maskptr-32;
			else
				srccount = filesize-32;
			bufend = buffer+size;
			buf = buffer;
			while ( (buf<bufend)&&(srccount>0) ) {
				if (!bit) {
					bit = 8;
					flag = *src++;
					srccount--;
				}
				if ( flag&0x80 ) {
					n = (*src++)*4+0x20;
					*buf++ = srcbuf[n];
					*buf++ = srcbuf[n+1];
					*buf++ = srcbuf[n+2];
					srccount--;
				} else {
					num  = *src++;					// BYTE
					srccount--;
					count = (((num>>4)&15)+2)*3;	// 4bitԡ. 2󤬺Ǿñ̡
					if ( (buf+count)>=bufend ) count = bufend-buf;
					repeat = buf-(index[num&15])*3;	// Index֤򤭤롩
					for (i=0; (i<count)&&(buf<bufend); i++) *buf++ = *repeat++;
				}
				bit--;
				flag <<= 1;
			}
		}
		
		
		png_structp     png_ptr;
		png_infop       info_ptr;
		unsigned char **image;
		k=0; l=0;
		image = (png_bytepp)malloc(ysize * sizeof(png_bytep));
		if(maskptr) {
			for (j = 0; j < ysize; j++)
				image[j] = (png_bytep)malloc(xsize * sizeof(png_byte) * 4);
			for(j=0; j<ysize; j++) {
				for(i=0;i<xsize*4; i++) {
					if(i%4 == 3) image[j][i] = mask[l++];
					else image[j][i] = buffer[k++];
				}
			}
		}
		else {
			for (j = 0; j < ysize; j++)
				image[j] = (png_bytep)malloc(xsize * sizeof(png_byte) * 3);
			for(j=0; j<ysize; j++) {
				for(i=0;i<xsize*3; i++) {
					image[j][i] = buffer[k++];
				}
			}
		}
		
		fp = fopen(argv[2], "wb");
		if(fp) {
			png_ptr = png_create_write_struct(
				PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
			info_ptr = png_create_info_struct(png_ptr);
			png_set_bgr(png_ptr);
			png_init_io(png_ptr, fp);
			if(maskptr) {
				png_set_IHDR(png_ptr, info_ptr, xsize, ysize,
					8, PNG_COLOR_TYPE_RGBA, PNG_INTERLACE_NONE,
					PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
			}
			else {
			png_set_IHDR(png_ptr, info_ptr, xsize, ysize,
					8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
					PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
			}
			png_write_info(png_ptr, info_ptr);
			png_write_image(png_ptr, image);
			png_write_end(png_ptr, info_ptr);
			png_destroy_write_struct(&png_ptr, &info_ptr);
			fclose(fp);
		}
		
		for(i = 0; i < ysize; i++) free(image[i]);
		free(image);
		free(srcbuf);
		free(buffer);
		free(image);
		if(maskptr) free(mask);
	}
	return 0;
}