//
//  PDTVImgView.m
//  PDTView
//
//  Created by tmkk on Fri Feb 11 2005.
//  Copyright (c) 2005 tmkk. All rights reserved.
//

#import "PDTVImgView.h"
#import "PDTVDoc.h"

@implementation PDTVImgView

- (IBAction)copy:(id)sender
{
	NSData *tiff = [[self image] TIFFRepresentation];
	NSPasteboard *pb = [NSPasteboard generalPasteboard];
	[pb declareTypes: [NSArray arrayWithObjects:NSTIFFPboardType, NSPICTPboardType, NSPDFPboardType, nil] owner: self];
	[pb setData: tiff forType: NSTIFFPboardType];
}

- (IBAction)paste:(id)sender
{
	[delegate paste];
}

- (BOOL)isPasteBoardValid
{
	NSPasteboard *pb = [NSPasteboard generalPasteboard];
	NSArray *types = [NSArray arrayWithObject:NSTIFFPboardType];
    NSString *bestType = [pb availableTypeFromArray:types];
	
    return (bestType != nil);
}

- (BOOL)validateMenuItem:(NSMenuItem *)item
{
	if ([item action] == @selector(paste:)) {
        return [self isPasteBoardValid];
    }
	else if ([item action] == @selector(delete:)) {
		return NO;
	}
	else if ([item action] == @selector(undo:)) {
		return NO;
	}
	else if ([item action] == @selector(redo:)) {
		return NO;
	}
	else if ([item action] == @selector(selectAll:)) {
		return NO;
	}
	else return YES;
}

@end
